pilha	EQU	2000H		; valor inicial do SP

PLACE	1000H			; zona de dados
base:	WORD	Soma		; endereo da rotina Soma
	WORD	Subtrai	; endereo da rotina Subtrai
	WORD	Mult		; endereo da rotina Mult
	WORD	Divide	; endereo da rotina Divide

PLACE	0000H			; zona de instrues
	MOV	SP, pilha	; limite superior da pilha
faz1:	MOV	R1, 7		; 1 operando
	MOV	R2, 4		; 2 operando
	MOV	R3, 0		; cdigo da soma
	CALL	Trata		; efectua soma
faz2:	MOV	R1, 5		; 1 operando
	MOV	R2, 8		; 2 operando
	MOV	R3, 2		; cdigo da multiplicao
	CALL	Trata		; efectua multiplicao
fim:	JMP	fim		; fim do programa

;*******************************************************************************
; Trata  invoca a operao indicada pelo 3 parmetro
; Entradas  R1  1 operando
;            R2  2 operando
;            R3  operao (0 soma, 1 subtraco, 2 multiplicao, 3 diviso)
; Sadas  R1  resultado da operao
; Destri  R0, R3
;*******************************************************************************
Trata:
	MOV	R0, base	; base da tabela de apontadores
	ADD	R3, R3	; duplica R3, pois a tabela  de apontadores e cada
				; elemento  um endereo que ocupa 2 bytes
	MOV	R3, [R0+R3]	; obtm o endereo da rotina pretendida
	CALL	R3		; invoca-a. Os operandos j esto em R1 e R2
	RET			; j est! O resultado foi deixado no R1

;*******************************************************************************
; Soma  Soma os dois operandos
; Entradas  R1  1 operando
;            R2  2 operando
; Sadas  R1  resultado da soma
;*******************************************************************************
Soma:
	ADD	R1, R2	; Executa operao
	RET			; termina, com resultado em R1
	
;*******************************************************************************
; Subtrai  Subtrai o 2 operando do 1 operando
; Entradas  R1  1 operando
;            R2  2 operando
; Sadas  R1  resultado da subtraco
;*******************************************************************************
Subtrai:
	SUB	R1, R2	; Executa operao
	RET			; termina, com resultado em R1
	
;*******************************************************************************
; Mult  Multiplica os dois operandos
; Entradas  R1  1 operando
;            R2  2 operando
; Sadas  R1  resultado da multiplicao
;*******************************************************************************
Mult:
	MUL	R1, R2	; Executa operao
	RET			; termina, com resultado em R1
	
;*******************************************************************************
; Divide  Divide o 1 operando do 2 operando (diviso inteira)
; Entradas  R1  1 operando
;            R2  2 operando
; Sadas  R1  resultado da diviso
;*******************************************************************************
Divide:
	DIV	R1, R2	; Executa operao
	RET			; termina, com resultado em R1
